/**
 * Copyright &copy; 2012-2016 <a href="https://github.com/thinkgem/jeesite">JeeSite</a> All rights reserved.
 */
package com.thinkgem.jeesite.common.utils;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;

import org.apache.commons.lang3.time.DateFormatUtils;

/**
 * 日期工具类, 继承org.apache.commons.lang.time.DateUtils类
 * @author ThinkGem
 * @version 2014-4-15
 */
public class DateUtils extends org.apache.commons.lang3.time.DateUtils {
	
	private static String[] parsePatterns = {
		"yyyy-MM-dd", "yyyy-MM-dd HH:mm:ss", "yyyy-MM-dd HH:mm", "yyyy-MM", 
		"yyyy/MM/dd", "yyyy/MM/dd HH:mm:ss", "yyyy/MM/dd HH:mm", "yyyy/MM",
		"yyyy.MM.dd", "yyyy.MM.dd HH:mm:ss", "yyyy.MM.dd HH:mm", "yyyy.MM"};

	/**
	 * 得到当前日期字符串 格式（yyyy-MM-dd）
	 */
	public static String getDate() {
		return getDate("yyyy-MM-dd");
	}
	
	/**
	 * 得到当前日期字符串 格式（yyyy-MM-dd） pattern可以为："yyyy-MM-dd" "HH:mm:ss" "E"
	 */
	public static String getDate(String pattern) {
		return DateFormatUtils.format(new Date(), pattern);
	}
	
	/**
	 * 得到日期字符串 默认格式（yyyy-MM-dd） pattern可以为："yyyy-MM-dd" "HH:mm:ss" "E"
	 */
	public static String formatDate(Date date, Object... pattern) {
		String formatDate = null;
		if (pattern != null && pattern.length > 0) {
			formatDate = DateFormatUtils.format(date, pattern[0].toString());
		} else {
			formatDate = DateFormatUtils.format(date, "yyyy-MM-dd");
		}
		return formatDate;
	}
	
	/**
	 * 得到日期时间字符串，转换格式（yyyy-MM-dd HH:mm:ss）
	 */
	public static String formatDateTime(Date date) {
		return formatDate(date, "yyyy-MM-dd HH:mm:ss");
	}

	/**
	 * 得到当前时间字符串 格式（HH:mm:ss）
	 */
	public static String getTime() {
		return formatDate(new Date(), "HH:mm:ss");
	}

	/**
	 * 得到当前日期和时间字符串 格式（yyyy-MM-dd HH:mm:ss）
	 */
	public static String getDateTime() {
		return formatDate(new Date(), "yyyy-MM-dd HH:mm:ss");
	}

	/**
	 * 得到当前年份字符串 格式（yyyy）
	 */
	public static String getYear() {
		return formatDate(new Date(), "yyyy");
	}

	/**
	 * 得到当前月份字符串 格式（MM）
	 */
	public static String getMonth() {
		return formatDate(new Date(), "MM");
	}

	/**
	 * 得到当天字符串 格式（dd）
	 */
	public static String getDay() {
		return formatDate(new Date(), "dd");
	}

	/**
	 * 得到当前星期字符串 格式（E）星期几
	 */
	public static String getWeek() {
		return formatDate(new Date(), "E");
	}
	
	/**
	 * 日期型字符串转化为日期 格式
	 * { "yyyy-MM-dd", "yyyy-MM-dd HH:mm:ss", "yyyy-MM-dd HH:mm", 
	 *   "yyyy/MM/dd", "yyyy/MM/dd HH:mm:ss", "yyyy/MM/dd HH:mm",
	 *   "yyyy.MM.dd", "yyyy.MM.dd HH:mm:ss", "yyyy.MM.dd HH:mm" }
	 */
	public static Date parseDate(Object str) {
		if (str == null){
			return null;
		}
		try {
			return parseDate(str.toString(), parsePatterns);
		} catch (ParseException e) {
			return null;
		}
	}

	/**
	 * 获取过去的天数
	 * @param date
	 * @return
	 */
	public static long pastDays(Date date) {
		long t = new Date().getTime()-date.getTime();
		return t/(24*60*60*1000);
	}

	/**
	 * 获取过去的小时
	 * @param date
	 * @return
	 */
	public static long pastHour(Date date) {
		long t = new Date().getTime()-date.getTime();
		return t/(60*60*1000);
	}
	
	/**
	 * 获取过去的分钟
	 * @param date
	 * @return
	 */
	public static long pastMinutes(Date date) {
		long t = new Date().getTime()-date.getTime();
		return t/(60*1000);
	}
	
	/**
	 * 转换为时间（天,时:分:秒.毫秒）
	 * @param timeMillis
	 * @return
	 */
    public static String formatDateTime(long timeMillis){
		long day = timeMillis/(24*60*60*1000);
		long hour = (timeMillis/(60*60*1000)-day*24);
		long min = ((timeMillis/(60*1000))-day*24*60-hour*60);
		long s = (timeMillis/1000-day*24*60*60-hour*60*60-min*60);
		long sss = (timeMillis-day*24*60*60*1000-hour*60*60*1000-min*60*1000-s*1000);
		return (day>0?day+",":"")+hour+":"+min+":"+s+"."+sss;
    }
	
	/**
	 * 获取两个日期之间的天数
	 * 
	 * @param before
	 * @param after
	 * @return
	 */
	public static double getDistanceOfTwoDate(Date before, Date after) {
		long beforeTime = before.getTime();
		long afterTime = after.getTime();
		return (afterTime - beforeTime) / (1000 * 60 * 60 * 24);
	}
	

	/**
	 * 获取今天凌晨
	 *
	 * @param dateTime
	 *            yyyy-MM-dd 00:00:00
	 */
	public static String getTodayStart() {
		Date currentTime = new Date();
		SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
		String dateString = formatter.format(currentTime);
		return dateString + " 00:00:00";
	}


	/**
	 * 获取某年第一天日期
	 * @param year 年份
	 * @return Date
	 */
	public static String getCurrYearFirst(int year,String pattern){
		SimpleDateFormat dateFormat = new SimpleDateFormat(pattern);
		Calendar calendar = Calendar.getInstance();
		calendar.clear();
		calendar.set(Calendar.YEAR, year);
		return dateFormat.format ( calendar.getTime());
	}

	/**
	 * 获取自定义昨天日期
	 *
	 * @param month 月份
	 *
	 * @return Date
	 */
	public static String getYesterday ( String dateTime,String pattern ) {
		SimpleDateFormat dateFormat = new SimpleDateFormat ( pattern);
		Calendar calendar = Calendar.getInstance ( );
		Date date = null;
		try {
			date = dateFormat.parse ( dateTime );
		} catch ( ParseException e ) {
			e.printStackTrace ( );
		}
		calendar.setTime ( date );
		calendar.add ( Calendar.DATE , - 1 );
		return dateFormat.format ( calendar.getTime ( ) );
	}

	/**
	 * 获取自定义昨天日期
	 *
	 * @param month 月份
	 *
	 * @return Date
	 */
	public static String getYesterday ( String pattern ) {
		SimpleDateFormat dateFormat = new SimpleDateFormat ( pattern);
		Calendar calendar = Calendar.getInstance ( );
		Date date = new Date();

		calendar.setTime ( date );
		calendar.add ( Calendar.DATE , - 1 );
		return dateFormat.format ( calendar.getTime ( ) );
	}

	/**
	 * 获取当月第一天
	 *
	 * @param yyyy-mm-dd
	 *
	 * @return Date
	 */
	public static String getFirstByMonth ( String dateTime ,String pattern) {
		SimpleDateFormat dateFormat = new SimpleDateFormat ( pattern );
		Calendar c = Calendar.getInstance ( );
		Date date = null;
		try {
			date = dateFormat.parse ( dateTime );
		} catch ( ParseException e ) {
			e.printStackTrace ( );
		}
		c.setTime ( date );
		c.set ( Calendar.DAY_OF_MONTH , 1 );//设置为1号,当前日期既为本月第一天
		return dateFormat.format ( c.getTime ( ) );
	}


	/**
	 * 获取某年第一天日期
	 * @param year 年份
	 * @return Date
	 */
	public static String getCurrYearFirst(String dateTime,String pattern){
		SimpleDateFormat dateFormat = new SimpleDateFormat ( pattern );
		Calendar c = Calendar.getInstance ( );
		Date date = null;
		try {
			date = dateFormat.parse ( dateTime );
		} catch ( ParseException e ) {
			e.printStackTrace ( );
		}
		c.setTime ( date );
		c.set(Calendar.DAY_OF_YEAR, 1);
		return dateFormat.format ( c.getTime());
	}

	/**
	 * @param args
	 * @throws ParseException
	 */
	public static void main(String[] args) throws ParseException {
		System.out.println(getCurrYearFirst("2018-03-16 12:21:22","yyyy-MM-dd HH:mm:ss"));
	}


}
